#include "stdafx.h"
#include "Translate.h"
#include "Events.h"

#define Str details.Fetch_String
#define Int details.Fetch_Int

class GUIDED_TOUR : public GameEvent
{
public:
  void Export(JWriter& jw);
  void Read(JReader& event, JReader& jr);

  int tour_x,tour_y;  // start location
  int facing; // start facing
  BOOL executeEvent;
  BOOL useStartLoc;
  int currStep;
  TOUR_STEP steps[MAX_TOUR_STEPS];
};



void Event_GuidedTour(JReader& event, JReader& details, JWriter& jw)
{
  GUIDED_TOUR guided_tour;
  guided_tour.Read(event,details);
  guided_tour.Export(jw);
}

void GUIDED_TOUR::Export(JWriter& jw)
{
  int i[2];
  GameEvent::Export(jw);
  jw.StartList(JKEY_PARTICULAR);
  i[0] = tour_x;
  i[1] = tour_y;
  jw.NameAndValue(JKEY_XY, i, 2);
  jw.NameAndValue(JKEY_FACING, facing);
  jw.NameAndBool(JKEY_USESTARTLOCATION, useStartLoc);   
  jw.NameAndBool(JKEY_EXECUTEEVENT, executeEvent);

  jw.StartArray(JKEY_STEPS);
  for (int j=0;j<MAX_TOUR_STEPS;j++)
  {
    steps[j].Export(jw, j);
  };
  jw.EndArray();
  jw.EndList();
}

void GUIDED_TOUR::Read(JReader& event, JReader& details)
{
  GameEvent::Read(event, GuidedTour);
  details.NameAndValue ("start_facing", facing);
  details.NameAndBool  ("start_loc_use", useStartLoc);   
  details.NameAndBool  ("dest_event_execute", executeEvent);
  details.NameAndValue ("start_loc_x", tour_x);
  details.NameAndValue ("start_loc_y", tour_y);

  {
    int stepNum;
    TOUR_STEP step;
    for (stepNum = 1; stepNum<=MAX_TOUR_STEPS; stepNum++)
    {
      step.Read(details, stepNum);
      steps[stepNum-1] = step;
    };
  };
  return;
}
