#include "stdafx.h"
#include "Translate.h"
#include "Events.h"

#define Str details.Fetch_String
#define Int details.Fetch_Int


void TEMPLE::Clear()
{ 
  GameEvent::Clear();
  
  forceExit=TRUE;
  allowDonations=TRUE;
  costFactor=Normal;
  maxLevel=7;
  donationTrigger=0;
  donationChain=0;
  templeSpells.Clear();
  totalDonation=0; 
  m_state = -1;
}


TEMPLE::TEMPLE(void) :  
   GameEvent(), 
   donationChain(0),
   templeSpells(*(new spellBookType)),
   //tcKey(-1)
   characterID()
{
  Clear(); 
  evType=TempleEvent;

}

TEMPLE::~TEMPLE(void)
{
  delete &templeSpells;
}



void Event_Temple(JReader& event, JReader& details, JWriter& jw)
{
  TEMPLE temple;
  temple.Read(event, details);
  temple.Export(jw);
}



void TEMPLE::Export(JWriter& jw)
{
  GameEvent::Export(jw);
  jw.StartList(JKEY_PARTICULAR);
  jw.NameAndBool(JKEY_FORCEEXIT, forceExit);
  jw.NameAndBool(JKEY_ALLOWDONATIONS, allowDonations);
  jw.NameAndEnum(JKEY_COSTFACTOR, costFactor);
  jw.NameAndValue(JKEY_MAXLEVEL, maxLevel);
  jw.NameAndValue(JKEY_DONATIONTRIGGER, donationTrigger);
  jw.NameAndValue(JKEY_DONATIONCHAIN, donationChain);
  jw.NameAndValue(JKEY_TOTALDONATION, totalDonation);

  templeSpells.Export(jw);
  jw.EndList();
}

void TEMPLE::Read(JReader& event, JReader& details)
{
  GameEvent::Read(event, TempleEvent);
  details.NameAndBool("force_backup_one_step"                 , forceExit);
  details.NameAndBool("allow_donations"                       , allowDonations);
  details.NameAndEnum("cost_modifier"                         , costFactor);
  details.NameAndValue("highest_spell_level_offered"          , maxLevel);
  details.NameAndValue("chain_event_donation_trigger_platinum", donationTrigger);
  details.NameAndValue("chain_event_donations"                , donationChain);
  details.NameAndValue("chain_event_donation_trigger_platinum", totalDonation);
  details.NameAndValue("text_1"                               , text);
  details.NameAndValue("text_2"                               , text2);
  details.NameAndValue("picture"                              , pic.filename);

  templeSpells.Read(details);
  return;
 }
