#include "stdafx.h"
#include "Translate.h"
#include "Events.h"

#define Str details.Fetch_String
#define Int details.Fetch_Int


class WHO_PAYS_EVENT_DATA : public GameEvent
{
public:
  void Export(JWriter& jw);
  void Read(JReader& event, JReader& jr);
  BOOL impossible;
  passwordActionType successAction;
  passwordActionType failAction;
  int gems;
  int jewels;
  int platinum;
  itemClassType moneyType; // which money type to take (plat,gold,etc)
  long Unused;
  DWORD successChain;
  DWORD failChain;
  TRANSFER_DATA successTransferData;
  TRANSFER_DATA failTransferData;
};




void Event_WhoPays(JReader& event, JReader& details, JWriter& jw)
{
  WHO_PAYS_EVENT_DATA who_pays_event_data;
  who_pays_event_data.Read(event, details);
  who_pays_event_data.Export(jw);
}


void WHO_PAYS_EVENT_DATA::Export(JWriter& jw)
{
  GameEvent::Export(jw);
  jw.StartList(JKEY_PARTICULAR);
  jw.NameAndBool(JKEY_POSSIBLE, !impossible);
  jw.NameAndValue(JKEY_GEMS, gems);
  jw.NameAndValue(JKEY_JEWELS, jewels);
  jw.NameAndValue(JKEY_PLATINUM, platinum);
  jw.NameAndValue(JKEY_SUCCESSCHAIN, successChain);
  jw.NameAndEnum(JKEY_SUCCESSACTION, successAction);
  if (successAction == Teleport)
  {
    successTransferData.Export(jw, JKEY_SUCCESSTELEPORT);
  };
  jw.NameAndValue(JKEY_FAILCHAIN, failChain);
  jw.NameAndEnum(JKEY_FAILACTION, failAction);
  if (failAction == Teleport)
  {
    failTransferData.Export(jw, JKEY_FAILTELEPORT);
  };
  jw.NameAndEnum(JKEY_MONEYTYPE, moneyType);
  jw.EndList();
}

void WHO_PAYS_EVENT_DATA::Read(JReader& event, JReader& details)
{
  bool possible = true;
  GameEvent::Read(event, WhoPays);
  //details.NameAndBool(JKEY_POSSIBLE, possible);
  impossible = !possible;
  //details.NameAndValue(JKEY_GEMS, gems);
  //details.NameAndValue(JKEY_JEWELS, jewels);
  //details.NameAndValue(JKEY_PLATINUM, platinum);
  details.NameAndValue(JKEY_SUCCESSAMOUNT, platinum);

  //details.NameAndValue(JKEY_SUCCESSCHAIN, successChain);
  //details.NameAndEnum(JKEY_SUCCESSACTION, successAction);
  details.NameAndValue(JKEY_SUCCESSEVENT, successChain);
  details.NameAndEnum(JKEY_success_action, successAction);

  successTransferData.Read(details, JKEY_SUCCESSTELEPORT, "teleport_dest_event_execute");
  details.NameAndValue(JKEY_FAILEVENT, failChain);
  details.NameAndEnum(JKEY_FAILACTION, failAction);
  failTransferData.Read(details, JKEY_FAILTELEPORT);
  details.NameAndEnum(JKEY_MONEYTYPE, moneyType);
  return;
}
