#include "stdafx.h"
#include "Translate.h"
//
extern FILE *f;
extern CString jsonPath;
void Line(const char *name, const char *value);
void Line(const char *name, int value);

#define Str(a)   spell.Fetch_String(a)
#define Int(a)   spell.Fetch_Int(a)
#define YesNo(a) spell.Fetch_YesNo(a)


void ConvertOneSpell(JReader& spell)
{
  spell.StartList(DBGID_oneSpell);
  Line("ID"              ,Int("id"));
  Line("name", Str("name"));
  Line("save_result",   Str("save_result")),
  Line("level", Int("spell_level"));
  Line("target_area_square_size", Int("target_area_square_size")),
  Line("target_min_count"       , Int("target_min_count")),
  Line("unsure_byte"            , Int("unsure_byte"));
  WriteLine(f, "casting sound"       , "");
  WriteLine(f, "Key"                 , "0");
  WriteLine(f, "cast msg"            , "");
  WriteLine(f, "missile sound"       , "");
  WriteLine(f, "coverage sound"      , "");
  WriteLine(f, "hit sound"           , "");
  WriteLine(f, "linger sound"        , "");
  WriteLine(f, "cast art"            , "");
  WriteLine(f, "missile art"         , "");
  WriteLine(f, "target cover art"    , "");
  WriteLine(f, "target hit art"      , "");
  WriteLine(f, "target linger art"   , "");
  {
    CString school, castBy;
    school = Str("spell_book");
    Line("school"                        , school);
    if (school == "cleric")     castBy = "cleric";
    if (school == "magic-user") castBy = "magicUser";
    if (school == "druid")      castBy = "cleric";
    if (school == "device")     castBy = "magicUser";
    WriteLine(f, "cast by"             , castBy);
  };
  Line("friendly fire ok"              , YesNo("target_friendly"));
  WriteLine(f, "cumulative"          , "");
  WriteLine(f, "can memorize"        , "");
  WriteLine(f, "allow scribe"        , "");
  WriteLine(f, "auto scribe"         , "");
  Line("in camp"                       , YesNo("cast_in_camp"));
  Line("in combat"                     , YesNo("cast_in_combat"));
  WriteLine(f, "can be dispelled"    , "");
  WriteLine(f, "lingers"             , "");
  WriteLine(f, "linger affects once" , "");
  Line("save versus"                   , Str("save_vs"));
  Line("Special Ability"               , Str("special_ability"));
  Line("targeting type"                , Str("target_type"));
  Line("casting time"                  , Int("cast_time_in_segments"));
  WriteLine(f, "casting time units"     , "");
  {
    CString duration;
    int baseDuration, levelDuration;
    baseDuration = Int("duration_base_rounds");
    levelDuration = Int("duration_rounds_added_per_level");
    duration.Format("%d+%d*level", baseDuration, levelDuration);
    WriteLine(f, "target druation"       , duration);
  };
  WriteLine(f, "duration units"        ,"");
  
  Line("Number of targets"               , Int("target_max_count"));
  Line("Cast Priority?"                  , Int("cast_priority"));
  Line("Combat Only?"                    , YesNo("combat_only"));
  Line("Non-combat Targeting?"           , Str("non_combat_targeting"));
  {
    CString range;
    int baseRange, levelRange;
    baseRange = Int("range_base_squares");
    levelRange = Int("range_squares_added_per_level");
    range.Format("%d+%d*level", baseRange, levelRange);
    WriteLine(f, "target range", range);
  };
  WriteLine(f, "attack bonus"                 ,"0");
  WriteLine(f, "damage"                       ,"0");
  WriteLine(f, "protection bonus"             ,"0");
  WriteLine(f, "healing"                      ,"0");
  WriteLine(f, "price"                        ,"0");
  WriteLine(f, "spell effect"                 ,"");
  WriteLine(f, "activate script"              ,"");
  WriteLine(f, "modify script"                ,"");
  WriteLine(f, "saving throw script"          ,"");
  WriteLine(f, "saving throw failed script"   ,"");
  WriteLine(f, "saving throw succeeded script","");
  //WriteLine(f, "spell attribute"              ,"");
  WriteLine(f, "begin script"                 ,"");
  WriteLine(f, "end script"                   ,"");

  spell.EndList(DBGID_oneSpell);







};


void ConvertSpells(JReader& spells)
{
  if (f != NULL)
  {
    die("Internal error in Spells.cpp.  f not null");
  };
  f = fopen(jsonPath + "spells.txt", "w");
  fprintf(f,"// Spell database file\n");
  fprintf(f,"// The line above **must** be the first line of the monsters file!!!\n\n");

  while (spells.Optional(), spells.NextEntry())
  {
    JReader spell(spells);
    fprintf(f,"\n\\(BEGIN)\n");
    ConvertOneSpell(spell);
    fprintf(f,"\\i(END)\n");
  };
  fclose(f);
  f = NULL;
}
